% function [ps,pf]= HREA(fname,xl,xu,n_obj,n_var,pop,Max_Gen)
%% 参数设置
clc;clear;
xl=[0 0];
xu=[1 2];
pop=200*2;
Max_fevs=10000*2;
n_obj= 2;
n_var= 2;
Max_Gen=50;
fname='MMF2';
%% 参数设置
eps= 0.3;
p = 0.5;
popsize=pop;
problemName = strcat("@",fname);
ObjectiveFunction=eval(problemName);
ArchiveMaxSize = popsize;
mu = 20;
mum = 20;
%% 初始化种群与外部存档

Population = CreateEmptyIndividuals(popsize);
Archive = CreateEmptyIndividuals(popsize);
for i=1:numel(Population)
    Population(i).Position= xl + (xu-xl).*rand(1,n_var); 
    Population(i).Cost=ObjectiveFunction(Population(i).Position)';
end
for i=1:numel(Population)
    Archive(i).Position= 0.*rand(1,n_var); 
    Archive(i).Cost=inf.*rand(1,n_var);
end
%% 计算拥挤度距离
 Population = Crowding(Population)
 
%% 外部存档更新
 Archive = ArchiveUpdate(Population,eps,ArchiveMaxSize);

%% Optimization
for gen=1:Max_Gen 
    gen
    if gen >= Max_Gen * 0.5 && rand < p
        Offspring = Variation(ObjectiveFunction,Archive,xl,xu,mu,mum,n_obj,n_var); 
        
    else
        Offspring = Variation(ObjectiveFunction,Population,xl,xu,mu,mum,n_obj,n_var);         
    end
    
    Population = EnvironmentalSelection(Population,Offspring,popsize);
    Archive = ArchiveUpdate([Archive;Offspring],eps,ArchiveMaxSize);
end
ps=[];pf=[];
n=numel(Archive);
for i=1:n
    ps=[ps;Archive(i).Position];
    pf=[pf;Archive(i).Cost];
end


%  end
% %% 绘图
ps=[];pf=[];
n=numel(Archive);
for i=1:n
    ps=[ps;Archive(i).Position];
    pf=[pf;Archive(i).Cost];
end
figure(1)
plot(ps(:,1),ps(:,2),'ro');
hold on;
figure(2)
plot(pf(:,1),pf(:,2),'ro');

%%  其他函数
function [Archive] = ArchiveUpdate(Archive,eps,ArchiveMaxSize)
Population=Archive;
npop = numel(Population);

%% 挑出global PF
[Population,FrontNo] = NDSort(Population,npop);
next = FrontNo==1;
first_pf = Population(next);
new_pop = first_pf;
remain_pop = Population(~next);
Population_X=[];new_pop_X=[];remain_pop_X=[];
for i=1:npop
Population_X=[Population_X;Population(i).Position];
end
for i=1:numel(new_pop)
new_pop_X=[new_pop_X;new_pop(i).Position];
end
for i=1:numel(remain_pop)
remain_pop_X=[remain_pop_X;remain_pop(i).Position];
end
V=0.2*prod(max(Population_X)-min(Population_X)).^(1./size(Population_X,2));

while ~isempty(numel(remain_pop))
    %% 删除与当前层距离很近的个体
    pdist2(new_pop_X,remain_pop_X);%规模：|new_pop_X|*|remain_pop_X|
    dist = min(pdist2(new_pop_X,remain_pop_X));%返回每一列的最小值
    index = dist<V;
    k = find(index);
    remain_pop_X(k,:) = [];
    remain_pop(k) = [];
    if isempty(remain_pop_X)
        break;
    end
    
    %% 挑选余下层中，满足用户给定条件的解
    [remain_pop,FrontNo] = NDSort( remain_pop,numel(remain_pop));
    pick_pop_X = remain_pop_X(FrontNo==1,:);
    pick_pop = remain_pop(FrontNo==1,:);
    for i = 1 : numel (pick_pop)
    pick_pop(i).Cost=pick_pop(i).Cost .* (1-eps);
    end
    [~,nF] = NDSort([pick_pop; first_pf],numel(pick_pop)+numel(first_pf));
    nF = nF(1:numel(pick_pop));
    maxnF = max(nF); % 有待实验
    
    if maxnF>1
        k = find(nF==1);
        l=find(FrontNo~=1);
        new_pop = [new_pop;pick_pop(k)];
        remain_pop = remain_pop(l);
        break;
    else
        new_pop = [new_pop;pick_pop];
        remain_pop = remain_pop(FrontNo~=1);
        
    end
end
CrowdDis=[];
for i=1:numel(new_pop)
CrowdDis=[CrowdDis,new_pop(i).CrowdingDistance];
end
[~,index] = sortrows([-CrowdDis']);%用CrowdDis同时去选择；依据第一列的数值按升序移动每一行，如果第一列的数值有相同的，依次往右比较
New_pop = [];
New_pop=[New_pop;new_pop(index)];
if numel(New_pop)>ArchiveMaxSize
    New_pop = New_pop(1:ArchiveMaxSize,:);
end
Archive = New_pop;
Archive = Crowding(Archive);
end

function Population = Crowding(Population)
    N = numel(Population);
    K=N-1;
    Pop=[];
    for i=1:N
    Pop=[Pop;Population(i).Cost];
    end
    Z = min(Pop,[],1);
    Zmax = max(Pop,[],1);
    pop=(Pop-repmat(Z,N,1))./repmat(Zmax-Z,N,1);
    distance=pdist2(pop,pop);
    [value,~]=sort(distance,2);%2表示对每一行进行排序,value 为每一行升序排列后的数，~为返回的排序后元素在原数组中的行位置或列位置.
    CrowdDis=K./sum(1./value(:,2:N),2);
    for i=1:N
    Population(i).CrowdingDistance=CrowdDis(i);
    end
end

function [Population] = EnvironmentalSelection(Population,Offspring,popsize)
 Parent=[Population;Offspring];
 n = numel(Parent);
Parent_X=[];Parent_F=[];
for i=1:n
    Parent_X=[Parent_X;Parent(i).Position];
end
for i=1:n
    Parent_F=[Parent_F;Parent(i).Cost];
end
%% Cal the local convergence
dist = pdist2(Parent_X ,Parent_X);
V=0.2*prod(max(Parent_X)-min(Parent_X)).^(1./size(Parent_X,2));
DominationX = zeros(n); % Pareto domination relationship between pair of solutions
for i=1:n
    for j=i+1:n
        if dist(i,j) > V
            continue
        end
        L1 = Parent_F(i) < Parent_F(j);
        L2 = Parent_F(i) > Parent_F(j);
        if all(L1|(~L2))
            DominationX(i,j) = 0;
            DominationX(j,i) = 1;
        elseif all(L2|(~L1))
            DominationX(i,j) = 1;
            DominationX(j,i) = 0;
        end
    end
end

LocalC = zeros(1,n);
for i=1:n
    tmp = dist(i,:);
    index = tmp<V;
    LocalC(i) = (sum(DominationX(i,index)))./sum(index);
end
dist = sort(pdist2(Parent_X,Parent_X));%sort(A) 对矩阵每一列元素按照升序排列。
CrowdDis = sum(dist(1:3,:));
[~,index] = sortrows([LocalC' -CrowdDis']);%用LocalC和CrowdDis同时去选择；依据第一列的数值按升序移动每一行，如果第一列的数值有相同的，依次往右比较
Parent_X = Parent_X(index,:);
Parent_F = Parent_F(index,:);

if length(Parent_X)>popsize
    Parent_X = Parent_X(1:popsize,:);
    Parent_F = Parent_F(1:popsize,:);
end
[h,~]=size(Parent_X);
for i= 1: h
    Population(i).Position=Parent_X(i,:);
    Population(i).Cost=Parent_F(i,:);
end
Population = Crowding(Population);

end

function [pop,FrontNo] = NDSort(pop,popsize)
npop=numel(pop);
chromosome=[];
V=0;
for i=1:npop
chromosome=[chromosome;pop(i).Cost];
end
[N,MM]=size(chromosome);
x=chromosome;
Y=x';
for i=1:MM%f1,f2
eval(['Y',num2str(i),'=','Y(i,:)',';']);
end
D=zeros(npop,npop);
FrontNo=zeros(1,npop);
 for i=1:MM
     m=Y(i,:);
     m;
     C=cnstCmpMat(m,N);
     D=D+C;
 end
D;
for i=1:npop%������Ŀ
    D(i,i)=0;
    for j=i+1:npop
        if D(i,j)==D(j,i)
             D(i,j)=0;
             D(j,i)=0;
        end
    end
end
D;
count=0;
front=1;
while count<npop
Q=[];
for i=1:npop
    M=max(D);
  if  M(i)>=0 && M(i)<MM
       Q=union(Q,i); 
      
       count=count+1; 
     
  end
end
for i=1:npop
       h=ismember(i,Q);
        if h==1
          a=front; 
          pop(i).Rank=a;
          FrontNo(i)=a;
        else
          pop(i).Rank=2;
          FrontNo(i)=2;
        end
end

MaxFNo=2;

end
end

function C= cnstCmpMat(m,N)

[a,b]=sort(m); 
C=zeros(N,N);
for j=1:N
    C(b(1,1),j)=1;
end
for i=2:N
    if a(1,i)==a(1,i-1)
        C(b(1,i),:)=C(b(1,i-1),:);
    else
        for j=i:N
            C(b(1,i),b(1,j))=1;
        end
    end
end
end

function p=BinaryTournamentSelection(pop)

    npop=numel(pop);
    
    i=randi([1 npop],1,2);
    
    p1=pop(i(1));
    p2=pop(i(2));
    
    if p1.Rank < p2.Rank
        p=p1;
    elseif p1.Rank > p2.Rank
        p=p2;
    else
        if p1.CrowdingDistance>p2.CrowdingDistance
            p=p1;
        else
            p=p2;
        end
    end

end

function pop=CreateEmptyIndividuals(n)

    if nargin<1
        n=1;
    end
    
    individual.Position=[];
    individual.Cost=[];
    individual.Rank=[];
    individual.CrowdingDistance=[];
%     individual.DominationSet=[];
%     individual.DominatedCount=[];
    
    pop=repmat(individual,n,1);
    
end

function Offspring = Variation(ObjectiveFunction,Population,xl,xu,mu,mum,n_obj,n_var)
P=[];M=n_obj;V=n_var;
l_limit=xl;u_limit=xu;
for i= 1:numel(Population)
    P=[P;Population(i).Position Population(i).Cost];
end
Population=P;
[N,m] = size(Population);

clear m
p = 1;
was_crossover = 0;
was_mutation = 0;


for i = 1 : N
    if rand(1) < 0.9
        child_1 = [];
        child_2 = [];
        parent_1 = round(N*rand(1));
        if parent_1 < 1
            parent_1 = 1;
        end
        parent_2 = round(N*rand(1));
        if parent_2 < 1
            parent_2 = 1;
        end
        while isequal(Population(parent_1,:),Population(parent_2,:))
            parent_2 = round(N*rand(1));
            if parent_2 < 1
                parent_2 = 1;
            end
        end
        parent_1 = Population(parent_1,:);
        parent_2 = Population(parent_2,:);
        for j = 1 : V
            u(j) = rand(1);
            if u(j) <= 0.5
                bq(j) = (2*u(j))^(1/(mu+1));
            else
                bq(j) = (1/(2*(1 - u(j))))^(1/(mu+1));
            end
            child_1(j) = ...
                0.5*(((1 + bq(j))*parent_1(j)) + (1 - bq(j))*parent_2(j));
            child_2(j) = ...
                0.5*(((1 - bq(j))*parent_1(j)) + (1 + bq(j))*parent_2(j));
            if child_1(j) > u_limit(j)
                child_1(j) = u_limit(j);
            elseif child_1(j) < l_limit(j)
                child_1(j) = l_limit(j);
            end
            if child_2(j) > u_limit(j)
                child_2(j) = u_limit(j);
            elseif child_2(j) < l_limit(j)
                child_2(j) = l_limit(j);
            end
        end
        child_1(:,V + 1: M + V) = ObjectiveFunction(child_1);
        child_2(:,V + 1: M + V) = ObjectiveFunction(child_2);
        was_crossover = 1;
        was_mutation = 0;
    else
        parent_3 = round(N*rand(1));
        if parent_3 < 1
            parent_3 = 1;
        end
        child_3 = Population(parent_3,:);
        for j = 1 : V
           r(j) = rand(1);
           if r(j) < 0.5
               delta(j) = (2*r(j))^(1/(mum+1)) - 1;
           else
               delta(j) = 1 - (2*(1 - r(j)))^(1/(mum+1));
           end
           child_3(j) = child_3(j) + delta(j);
           if child_3(j) > u_limit(j)
               child_3(j) = u_limit(j);
           elseif child_3(j) < l_limit(j)
               child_3(j) = l_limit(j);
           end
        end 
        child_3(:,V + 1: M + V) = ObjectiveFunction(child_3(1:V));
        was_mutation = 1;
        was_crossover = 0;
    end
    if was_crossover
        child(p,:) = child_1;
        child(p+1,:) = child_2;
        was_cossover = 0;
        p = p + 2;
    elseif was_mutation
        child(p,:) = child_3(1,1 : M + V);
        was_mutation = 0;
        p = p + 1;
    end
end
 f = child;
 [hang,lie]=size(f);
 Offspring = CreateEmptyIndividuals(hang);
 for i=1:hang
     Offspring(i).Position=f(i,1:V);
     Offspring(i).Cost=f(i,V + 1: M + V);
 end
end