% function [ ps,pf] = MMO_DE_CSCD( func_name,VRmin,VRmax,n_obj,NP,Max_Gen )
clc;clear;
VRmin=[0 0];
VRmax=[1 2];
NP=200*2;
Max_fevs=10000*2;
Max_Gen=fix(Max_fevs/NP);
func_name='MMF2';
n_obj=2;

%%
n_var=size(VRmin,2);    %Obtain the dimensions of decision space
Max_FES=Max_Gen*NP;     %Maximum fitness evaluations
%% Initialize population
VRmin=repmat(VRmin,NP,1);
VRmax=repmat(VRmax,NP,1);
pos=VRmin+(VRmax-VRmin).*rand(NP,n_var); %initialize the positions of the individuals
%% Evaluate the population
fitness=zeros(NP,n_obj);
for i=1:NP;
    fitness(i,:)=feval(func_name,pos(i,:));
end
fitcount=NP;            % count the number of fitness evaluations
G=0;

%% main loop
while fitcount <= Max_FES
    G=G+1;
    Parentstar=[pos,fitness];
    K=10;
    Parentstar = non_domination_scd_kmeans_sort(Parentstar,n_obj,n_var,K);% n_var+n_obj+1: the level of front   +2��the decision space distance +3��CSCD value  +4��the objective space distance
    
    % calculate the number of individals in each front
    Total_pf = max(Parentstar(:,n_var+n_obj+1));
    pop = cell(Total_pf,1);
    num= zeros(Total_pf,1);
    
    % divide the population into multiple cells based on their fornt
    for i=1:NP
        pop{Parentstar(i,n_obj+n_var+1)} = [ pop{Parentstar(i,n_obj+n_var+1)};Parentstar(i,:)];
        num(Parentstar(i,n_obj+n_var+1)) = num(Parentstar(i,n_obj+n_var+1)) + 1;
    end
    
    % sort the individuals in each front based on CSCD value
    for i=1:Total_pf
        [~,index_sorted_on_scd]= sort(pop{i,1}(:,n_var+n_obj+3),'descend');  
        pop{i,1}= pop{i,1}(index_sorted_on_scd,:);
    end
    
    offspring = [];
    for i=1: Total_pf
        u = zeros(num(i),n_var);
        for j= 1 : size(pop{i,1},1)
            % select exemplar based on the proposed DBESM mechanism
            if i==1
                r_pf(1:3) = 1;
            else
                r_pf = ceil(rand(1,3)*(i-1));
            end
            
            if  num(r_pf(1)) < 3
                r1 = ceil(rand* num(r_pf(1))); 
            else
                r1 = min(ceil(0.1 * num(r_pf(1))),3);  % p = 0.1;
            end
          
            distance = sum((repmat(pop{i,1}(j,1:n_var), r1 ,1) - pop{r_pf(1),1}(1:r1,1:n_var)).^2,2);
            if length(distance) == 1
                select_index = r1;
            else
                if length(find(max(distance)==distance))== r1
                    select_index = ceil(rand*r1);
                else
                    distance = max(distance) - distance;
                    select_pro =  distance./(sum(distance));
                    true_pro = cumsum(select_pro);
                    select_index = find(rand<true_pro);
                end
            end
            
            r2 = ceil(rand*num(r_pf(2)));
            r3 = ceil(rand*num(r_pf(3)));
            % Mutation
            v = pop{i,1}(j,1:n_var) + 0.8*(pop{r_pf(1),1}(select_index(1),1:n_var) - pop{i,1}(j,1:n_var) + pop{r_pf(2),1}(r2,1:n_var) -pop{r_pf(3),1}(r3,1:n_var));
            v = boundConstraint(v, pop{i,1}(j,:), [VRmin(1,:);VRmax(1,:)]);
            % Crossover
            jrand = ceil(rand*n_var);
            for h=1:n_var
                if rand<1 || h==jrand
                    u(j,h) = v(1,h);
                else
                    u(j,h) = pop{i,1}(j,h);
                end
            end
        end
        offspring = [offspring;u];
    end
    
    % Evaluate offspring
    for i=1:size(offspring,1);
        offspring_fitness(i,:)=feval(func_name,offspring(i,:));
        fitcount = fitcount +1 ;
    end
    temp_pop = [pos,fitness;offspring,offspring_fitness];
    temp_pop = non_domination_scd_kmeans_sort(temp_pop ,n_obj,n_var,K);
    
    % Environmental seceltion
    Parent = replace_decision_chromosome_kmeans(temp_pop,n_obj,n_var, NP);
    pos = Parent(:,1:n_var);
    fitness = Parent(:,n_var+1:n_var+n_obj);
    
end
% Output
ps = Parent(Parent(:,n_var+n_obj+1)==1,1:n_var);
pf = Parent(Parent(:,n_var+n_obj+1)==1,n_var+1:n_var+n_obj);
% end
%% plot
figure(1)
plot(ps(:,1),ps(:,2),'o')
figure(2)
plot(pf(:,1),pf(:,2),'o')




%%   子函数
function f  = replace_decision_chromosome_kmeans(intermediate_chromosome, M, V,pop)

%第二判定标准选x空间距离，按x空间拥挤距离降序排列，选前几个
[ C,IA,IC ] = unique(intermediate_chromosome(:,1:V),'rows');
intermediate_chromosome = intermediate_chromosome(IA,:);
%           IA为矩阵C中的元素在矩阵A中的位置，
%
%           IC为矩阵A中的元素在矩阵C中的位置。

[N, m] = size(intermediate_chromosome);

% Get the index for the population sort based on the rank
[temp,index] = sort(intermediate_chromosome(:,M + V + 1));

clear temp m

% Now sort the individuals based on the index
for i = 1 : N
    sorted_chromosome(i,:) = intermediate_chromosome(index(i),:);
end

% Find the maximum rank in the current population
max_rank = max(intermediate_chromosome(:,M + V + 1));

% Start adding each front based on rank and crowing distance until the
% whole population is filled.
previous_index = 0;
for i = 1 : max_rank
    % Get the index for current rank i.e the last the last element in the
    % sorted_chromosome with rank i.
    current_index = max(find(sorted_chromosome(:,M + V + 1) == i));
    
    % Check to see if the population is filled if all the individuals with
    % rank i is added to the population.
    if current_index > pop
        % If so then find the number of individuals with in with current
        % rank i.
        remaining = pop - previous_index;
        % Get information about the individuals in the current rank i.
        temp_pop = ...
            sorted_chromosome(previous_index + 1 : current_index, :);
        % Sort the individuals with rank i in the descending order based on
        % the crowding distance.
        [temp_sort,temp_sort_index] = ...
            sort(temp_pop(:, M + V + 3),'descend');
        %%
        % Start filling individuals into the population in descending order
        % until the population is filled.
        for j = 1 : remaining
            f(previous_index + j,:) = temp_pop(temp_sort_index(j),:);
        end
        return;
    elseif current_index < pop
        % Add all the individuals with rank i into the population.
        f(previous_index + 1 : current_index, :) = ...
            sorted_chromosome(previous_index + 1 : current_index, :);
    else
        % Add all the individuals with rank i into the population.
        f(previous_index + 1 : current_index, :) = ...
            sorted_chromosome(previous_index + 1 : current_index, :);
        return;
    end
    % Get the index for the last added individual.
    previous_index = current_index;
end
end

function f = non_domination_scd_kmeans_sort(x, n_obj, n_var,KK)
% non_domination_scd_sort:  sort the population according to non-dominated relationship and special crowding distance

[N_particle, ~] = size(x);% Obtain the number of particles

% Initialize the front number to 1.
front = 1;

% There is nothing to this assignment, used only to manipulate easily in
% MATLAB.
F(front).f = [];
individual = [];

%% Non-Dominated sort.

for i = 1 : N_particle
    % Number of individuals that dominate this individual
    individual(i).n = 0;
    % Individuals which this individual dominate
    individual(i).p = [];
    for j = 1 : N_particle
        dom_less = 0;
        dom_equal = 0;
        dom_more = 0;
        for k = 1 : n_obj
            if (x(i,n_var + k) < x(j,n_var + k))
                dom_less = dom_less + 1;
            elseif (x(i,n_var + k) == x(j,n_var + k))
                dom_equal = dom_equal + 1;
            else
                dom_more = dom_more + 1;
            end
        end
        if dom_less == 0 && dom_equal ~= n_obj
            individual(i).n = individual(i).n + 1;
        elseif dom_more == 0 && dom_equal ~= n_obj
            individual(i).p = [individual(i).p j];
        end
    end
    if individual(i).n == 0
        x(i,n_obj + n_var + 1) = 1;
        F(front).f = [F(front).f i];
    end
end
% Find the subsequent fronts
while ~isempty(F(front).f)
    Q = [];
    for i = 1 : length(F(front).f)
        if ~isempty(individual(F(front).f(i)).p)
            for j = 1 : length(individual(F(front).f(i)).p)
                individual(individual(F(front).f(i)).p(j)).n = ...
                    individual(individual(F(front).f(i)).p(j)).n - 1;
                if individual(individual(F(front).f(i)).p(j)).n == 0
                    x(individual(F(front).f(i)).p(j),n_obj + n_var + 1) = ...
                        front + 1;
                    Q = [Q individual(F(front).f(i)).p(j)];
                end
            end
        end
    end
    front =  front + 1;
    F(front).f = Q;
end



% Sort the population according to the front number
[~,index_of_fronts] = sort(x(:,n_obj + n_var + 1));
for i = 1 : length(index_of_fronts)
    sorted_based_on_front(i,:) = x(index_of_fronts(i),:);
end
%% 
% perfrom k-means in each front, then calculate the decision space distance
finalpop = [];
avg_crowd_dist_var = [];
for front = 1 : (length(F)-1)
    front_index = find(sorted_based_on_front(:,n_obj + n_var + 1)==front);
    zhongjianpop = sorted_based_on_front(front_index,:);
    K = ceil(length(front_index)/KK);
    if size(zhongjianpop,1) < K
        keyboard
    end
    [ind,~] = kmeans(zhongjianpop(:,1:n_var),K);
    pop=cell(max(ind),1);
    for i1=1:length(ind)
        pop{ind(i1)} = [pop{ind(i1)};zhongjianpop(i1,:)];
    end
    
    for i2= 1 : size(pop,1)
        crowd_dist_obj = 0;
        y = pop{i2};
        sorted_based_on_objective = [];
        for i = 1 : n_var
            [sorted_based_on_objective, index_of_objectives] = ...
                sort(y(:,i));
            sorted_based_on_objective = [];
            for j = 1 : length(index_of_objectives)
                sorted_based_on_objective(j,:) = y(index_of_objectives(j),:);
            end
            f_max = ...
                sorted_based_on_objective(length(index_of_objectives), i);
            f_min = sorted_based_on_objective(1,  i);
            
            if length(index_of_objectives)==1
                y(index_of_objectives(1),n_obj + n_var + 1 + i) = 1;  %If there is only one point in current front
            elseif length(index_of_objectives)==2
                y(index_of_objectives(1),n_obj + n_var + 1 + i) = 1;
                y(index_of_objectives(length(index_of_objectives)),n_obj + n_var + 1 + i)=1;
            else
                y(index_of_objectives(length(index_of_objectives)),n_obj + n_var + 1 + i)...
                    = 2*(sorted_based_on_objective(length(index_of_objectives), i)-...
                    sorted_based_on_objective(length(index_of_objectives) -1, i))/(f_max - f_min);
                y(index_of_objectives(1),n_obj + n_var + 1 + i)=2*(sorted_based_on_objective(2, i)-...
                    sorted_based_on_objective(1, i))/(f_max - f_min);
            end
            for j = 2 : length(index_of_objectives) - 1
                next_obj  = sorted_based_on_objective(j + 1, i);
                previous_obj  = sorted_based_on_objective(j - 1,i);
                if (f_max - f_min == 0)
                    y(index_of_objectives(j),n_obj + n_var + 1 + i) = 1;
                else
                    y(index_of_objectives(j),n_obj + n_var + 1 + i) = ...
                        (next_obj - previous_obj)/(f_max - f_min);
                end
            end
        end
        %% Calculate distance in decision space
        crowd_dist_var = [];
        crowd_dist_var(:,1) = zeros(size(pop{i2},1),1);
        for ii = 1 : n_var
            crowd_dist_var(:,1) = crowd_dist_var(:,1) + y(:,n_obj + n_var + 1 + ii);
        end
        crowd_dist_var=crowd_dist_var./n_var;
        %avg_crowd_dist_var_k=mean(crowd_dist_var);
        y(:,n_obj+n_var+2)=crowd_dist_var;
        y = y(:,1 : n_obj + n_var+2 );
        finalpop=[finalpop;y];
       % avg_crowd_dist_var(front) = [avg_crowd_dist_var(front);avg_crowd_dist_var_k];
    end
end

sorted_based_on_front = [];
%% calculate the objective space distance
[~,index_of_fronts] = sort(finalpop(:,n_obj + n_var + 1));
for i = 1 : length(index_of_fronts)
    sorted_based_on_front(i,:) = finalpop(index_of_fronts(i),:);
   % avg_crowd_dist_var(i,:) = avg_crowd_dist_var(index_of_fronts(i),:);
end

  current_index = 0;

%% CSCD

    for front = 1 : (length(F) - 1)
  
        crowd_dist_obj = 0;
        y = [];
        previous_index = current_index + 1;
        for i = 1 : length(F(front).f)
            y(i,:) = sorted_based_on_front(current_index + i,:);%put the front_th rank into y
        end
        current_index = current_index + i;
   % Sort each individual based on the objective
        sorted_based_on_objective = [];
        for i = n_var+1 : n_obj+n_var
            [sorted_based_on_objective, index_of_objectives] = ...
                sort(y(:,i));
            sorted_based_on_objective = [];
            for j = 1 : length(index_of_objectives)
                sorted_based_on_objective(j,:) = y(index_of_objectives(j),:);
            end
            f_max = ...
                sorted_based_on_objective(length(index_of_objectives), i);
            f_min = sorted_based_on_objective(1,  i);

            if length(index_of_objectives)==1
                y(index_of_objectives(1),n_obj + n_var + 1 + i) = 1;  %If there is only one point in current front
            elseif i>n_var
                % deal with boundary points in objective space
                % In minimization problem, set the largest distance to the low boundary points and the smallest distance to the up boundary points
                y(index_of_objectives(1),n_obj + n_var + 1 + i) = 1;
                y(index_of_objectives(length(index_of_objectives)),n_obj + n_var + 1 + i)=0;
            end
             for j = 2 : length(index_of_objectives) - 1
                next_obj  = sorted_based_on_objective(j + 1, i);
                previous_obj  = sorted_based_on_objective(j - 1,i);
                if (f_max - f_min == 0)
                    y(index_of_objectives(j),n_obj + n_var + 1 + i) = 1;
                else
                    y(index_of_objectives(j),n_obj + n_var + 1 + i) = ...
                         (next_obj - previous_obj)/(f_max - f_min);
                end
             end
        end
    %% Calculate distance in objective space
        crowd_dist_obj = [];
        crowd_dist_obj(:,1) = zeros(length(F(front).f),1);
        for i = 1 : n_obj
            crowd_dist_obj(:,1) = crowd_dist_obj(:,1) + y(:,n_obj + n_var + 1+n_var + i);
        end
        crowd_dist_obj=crowd_dist_obj./n_obj;
        avg_crowd_dist_obj=mean(crowd_dist_obj);
    %% Calculate special crowding distance
        special_crowd_dist=zeros(length(F(front).f),1);
        avg_crowd_dist_var = mean(y(:,n_var+n_obj+2));
        for i = 1 : length(F(front).f)
            crowd_dist_var(i) = y(i,n_var+n_obj+2);
            if crowd_dist_obj(i)>avg_crowd_dist_obj||crowd_dist_var(i)>avg_crowd_dist_var
                special_crowd_dist(i)=max(crowd_dist_obj(i),crowd_dist_var(i)); % Eq. (6) in the paper
            else
                special_crowd_dist(i)=min(crowd_dist_obj(i),crowd_dist_var(i)); % Eq. (7) in the paper
            end
        end
        y(:,n_obj + n_var + 3) = special_crowd_dist;
        y(:,n_obj+n_var+4)=crowd_dist_obj;
        [~,index_sorted_based_crowddist]=sort(special_crowd_dist,'descend');%sort the particles in the same front according to CSCD
        y=y(index_sorted_based_crowddist,:);
        y = y(:,1 : n_obj + n_var+4 );
        z(previous_index:current_index,:) = y;
    end
f= z();
end

function vi = boundConstraint (vi, pop, lu)

% if the boundary constraint is violated, set the value to be the middle
% of the previous value and the bound
%
% Version: 1.1   Date: 11/20/2007
% Written by Jingqiao Zhang, jingqiao@gmail.com

[NP, D] = size(pop);  % the population size and the problem's dimension

%% check the lower bound
xl = repmat(lu(1, :), NP, 1);
pos = vi < xl;
vi(pos) = (pop(pos) + xl(pos)) / 2;

%% check the upper bound
xu = repmat(lu(2, :), NP, 1);
pos = vi > xu;
vi(pos) = (pop(pos) + xu(pos)) / 2;
end
