function [ps,pf]=MOAGDE(fname,xl,xu,n_obj,n_var,pop,Max_Gen)
% clc;clear;
% xl=[0 0];
% xu=[1 2];
% pop=200*2;
% Max_fevs=10000*2;
% Max_Gen=fix(Max_fevs/pop);
% fname='MMF2';
% n_obj=2;
% n_var=2;

%%  
GEN = Max_Gen;
D=n_var;
NP=pop;
n_obj=n_obj;
L=xl;
H=xu;
%% 
problemName = strcat("@",fname);
ObjectiveFunction=eval(problemName);
X = zeros(D,1); % trial vector
Pop = zeros(D,NP); % population
Fit = zeros(NP,n_obj); % fitness of the population
r = zeros(3,1); % randomly selected indices
Archive_member_no = 0;
bestFitness=inf*ones(1,n_obj);
bestSolution=inf*ones(1,D);
Archive_X=zeros(NP,D);
Archive_F=ones(NP,n_obj)*inf;
ArchiveMaxSize = NP;
% *********************** %
% ** CREATE POPULATION ** %
% *********************** %

for j = 1:NP % initialize each individual
    Pop(:,j) = L + (H-L).*rand(1,D); % within b.constraints
    % Fit(1,j)=testFunction(Pop(:,j), fhd, fNumber); 
end
%[~, iBest]=min(Fit);
% ****************** %
% ** OPTIMIZATION ** %
% ****************** %

Cr_All=zeros(1,2);
NW=zeros(1,2);

for g = 1:GEN % for each generation
    
    for i=1:NP %Calculate all the objective values first
        Fit(i,:)=ObjectiveFunction(Pop(:,i)');
        if dominates(Fit(i,:),bestFitness)
            bestFitness=Fit(i,:);
            bestSolution=Pop(:,i)';
        end
    end
    
    [Archive_X, Archive_F, Archive_member_no]=UpdateArchive(Archive_X, Archive_F, Pop', Fit, Archive_member_no);
    
    if Archive_member_no>ArchiveMaxSize
        Archive_mem_ranks=RankingProcess(Archive_F, ArchiveMaxSize, n_obj);
        [Archive_X, Archive_F, ~, Archive_member_no]=HandleFullArchive(Archive_X, Archive_F, Archive_member_no, Archive_mem_ranks, ArchiveMaxSize);
    else
        Archive_mem_ranks=RankingProcess(Archive_F, ArchiveMaxSize, n_obj);
    end
    Archive_mem_ranks=RankingProcess(Archive_F, Archive_member_no, n_obj);
    allRank=RankingProcess(Fit, Pop', n_obj);
    index=RouletteWheelSelection(1./Archive_mem_ranks);
    if index==-1
        index=1;
    end
    % Update the best Organism
    bestSolution=Archive_X(index,:);
    bestFitness=Archive_F(index,:);
    
    
    CrPriods_Index=zeros(1,NP);
    Sr=zeros(1,2);
    CrPriods_Count=zeros(1,2);
    for j = 1:NP % for each individual
         
         %%%%%%%%ADAPTIVE CR RULE  %%%%%%%%%%%%%%%%%%%%%%%%%
            Ali = rand;
            if(g<=1) % Do for the first Generation
                if (Ali<=1/2)
                    CR=0.05+0.1*rand(1,1);
                    CrPriods_Index(j)=1;
                
                else
                    CR=0.9+0.1*rand(1,1);
                    CrPriods_Index(j)=2;    
                end
                CrPriods_Count(CrPriods_Index(j))=CrPriods_Count(CrPriods_Index(j)) + 1;
            else
                 if (Ali<=NW(1))
                    CR=0.05+0.1*rand(1,1);
                    CrPriods_Index(j)=1;
                
                 else
                    CR=0.9+0.1*rand(1,1);
                    CrPriods_Index(j)=2;    
                end
                CrPriods_Count(CrPriods_Index(j))=CrPriods_Count(CrPriods_Index(j)) + 1;
            end

            %%%%%%%%%%%%%%%%%END OF CR RULE%%%%%%%%%%%%%%%%%%%%%%%%%%%
                f=allRank;
                [~, in]=sort(f,'ascend');
                AA=[in(1) in(2) in(3)  in(4) in(5)  ];
                BB=[in(46) in(47) in(48) in(49) in(50) ];
                CC=[in(6) in(7) in(8) in(9) in(10) in(11) in(12) in(13) in(14) in(15) in(16) in(17) in(18) in(19) in(20) in(21) in(22) in(23) in(24) in(25) in(26) in(27) in(28) in(29) in(30) in(31) in(32) in(33) in(34) in(35) in(36) in(37) in(38) in(39) in(40) in(41) in(42) in(43) in(44) in(45)];
               
            % choose three random individuals from population,
            % mutually different 

           paraIndex=floor (rand(1,1)*length(AA))+1;
                paraIndex1=floor (rand(1,1)*length(BB))+1;
                paraIndex2=floor (rand(1,1)*length(CC))+1;
                r(1) = AA(paraIndex);
                r(2) = BB(paraIndex1);
                r(3) = CC(paraIndex2);

                F=0.1+0.9*rand(1,1);
               
                Rnd = floor(rand()*D) + 1;
                for i = 1:D
                    if ( rand()<CR ) || ( Rnd==i )
                        X(i)=Pop(i,r(3))+F*(Pop(i,r(1))-(Pop(i,r(2))));
                    else
                        X(i) = Pop(i,j);
                    end
                end
        % end%end of All cases
        % verify boundary constraints
        % verify boundary constraints
        for i = 1:D
            if (X(i)<L(i))||(X(i)>H(i))
                X(i) = L(i) + (H(i)-L(i))*rand();
            end
        end
        % select the best individual
        % between trial and current ones
        % calculate fitness of trial individual   
        XPf=ObjectiveFunction(X');
        % if trial is better or equal than current
        % CRRatio(find(A==CRs(j)))=CRRatio(find(A==CRs(j)))+1-(min(f,Fit(j))/max(f,Fit(j)));
        Sr (CrPriods_Index(j)) = Sr(CrPriods_Index(j)) +1;

        Pop(:,j) = X; % replace current by trial
        Fit(j,:) = XPf ;
        % if trial is better than the best
    end
    CrPriods_Count(CrPriods_Count==0)=0.0001;
    Sr=Sr./CrPriods_Count;
%%%%%%%%%%%%%%%%USING SR ONLY%%%%%%%%%%5    
    if(sum(Sr)==0)
        W=[1/2 1/2];
    else
        W=Sr/sum(Sr);
    end
    
%%%%%%%%%%%%%%%%%%%%%%%%%%5
    NW=(NW*(g-1)+W)/g;
    Cr_All=Cr_All+CrPriods_Count;
    display(['At the iteration ', num2str(g), ' best fitness ', num2str(bestFitness)]);
    
end
ps=Archive_X;
pf=Archive_F;
% 
% figure(1)
% plot(ps(:,1),ps(:,2),'o')
% figure(2)
% plot(pf(:,1),pf(:,2),'o')
end

%_________________________________________________________________________________
function o=dominates(x,y)
    
    o=all(x<=y) && any(x<y);

end
function [Archive_X_Chopped, Archive_F_Chopped, Archive_mem_ranks_updated, Archive_member_no]=HandleFullArchive(Archive_X, Archive_F, Archive_member_no, Archive_mem_ranks, ArchiveMaxSize)


for i=1:size(Archive_F,1)-ArchiveMaxSize
    index=RouletteWheelSelection(Archive_mem_ranks);
    %[value index]=min(Archive_mem_ranks);
    
    Archive_X=[Archive_X(1:index-1,:) ; Archive_X(index+1:Archive_member_no,:)];
    Archive_F=[Archive_F(1:index-1,:) ; Archive_F(index+1:Archive_member_no,:)];
    Archive_mem_ranks=[Archive_mem_ranks(1:index-1) Archive_mem_ranks(index+1:Archive_member_no)];
    Archive_member_no=Archive_member_no-1;
end

Archive_X_Chopped=Archive_X;
Archive_F_Chopped=Archive_F;
Archive_mem_ranks_updated=Archive_mem_ranks;
end
% function y = MMF1(x)
% % 1<=x1<=3    -1<=x2<=1
%     y=zeros(2,1);
%     x(1)=abs((x(1)-2));
%     y(1)      = x(1);             
%     y(2)      = 1.0 - sqrt(x(1)) + 2.0*(x(2)-sin(6*pi*x(1)+pi))^2;
%  
% end
function ranks=RankingProcess(Archive_F, ArchiveMaxSize, obj_no)

global my_min;
global my_max;

%if all(my_min>min(Archive_F))
if size(Archive_F,1) == 1 && size(Archive_F,2) == 2
    my_min = Archive_F;
    my_max = Archive_F;
else
    my_min=min(Archive_F);
    %end

    %if all(my_max<max(Archive_F))
    my_max=max(Archive_F);
    %end
end

r=(my_max-my_min)/(20);
ranks=zeros(1,size(Archive_F,1));

for i=1:size(Archive_F,1)
    ranks(i)=0;
    for j=1:size(Archive_F,1)
        flag=0; % a flag to see if the point is in the neoghbourhood in all dimensions.
        for k=1:obj_no
            if (abs(Archive_F(j,k)-Archive_F(i,k))<r(k))
            %if ((sum(Archive_F(j,k).^obj_no-Archive_F(i,k).^obj_no))^(1/obj_no)<r(k))
                %ranks(i)=ranks(i)+sqrt(sum((Archive_F(i,:)-Archive_F(j,:)).^2));
                flag=flag+1;
            end
        end
        if flag==obj_no
            ranks(i)=ranks(i)+1;
        end
    end
end
end
function choice = RouletteWheelSelection(weights)
  accumulation = cumsum(weights);
  p = rand() * accumulation(end);
  chosen_index = -1;
  for index = 1 : length(accumulation)
    if (accumulation(index) > p)
      chosen_index = index;
      break;
    end
  end
  choice = chosen_index;
end
% function [fname,n_var, n_obj, xl, xu] = terminate_problem(index)
%     switch index
%         case 1
%             fname='MMF1';  % function name
%             n_obj=2;       % the dimensions of the decision space
%             n_var=2;       % the dimensions of the objective space
%             xl=[1 -1];     % the low bounds of the decision variables
%             xu=[3 1];      % the up bounds of the decision variables
%     end
% end
function [Archive_X_updated, Archive_F_updated, Archive_member_no]=UpdateArchive(Archive_X, Archive_F, Particles_X, Particles_F, Archive_member_no)
Archive_X_temp=[Archive_X ; Particles_X];
Archive_F_temp=[Archive_F ; Particles_F];

o=zeros(1,size(Archive_F_temp,1));

for i=1:size(Archive_F_temp,1)
    o(i)=0;
    for j=1:i-1
        if any(Archive_F_temp(i,:) ~= Archive_F_temp(j,:))
            if dominates(Archive_F_temp(i,:),Archive_F_temp(j,:))
                o(j)=1;
            elseif dominates(Archive_F_temp(j,:),Archive_F_temp(i,:))
                o(i)=1;
                break;
            end
        else
            o(j)=1;
            o(i)=1;
        end
    end
end


Archive_member_no=0;
index=0;
for i=1:size(Archive_X_temp,1)
    if o(i)==0
        Archive_member_no=Archive_member_no+1;
        Archive_X_updated(Archive_member_no,:)=Archive_X_temp(i,:);
        Archive_F_updated(Archive_member_no,:)=Archive_F_temp(i,:);
    else
        index=index+1;
    end
end
end
