%     function [ps,pf]=PSA_MODE_AP(fname,xl,xu,n_obj,n_var,pop,Max_Gen)
clc;clear;
addpath(genpath('MM_testfunctions/'));%matlab 添加当前文件夹及子文件夹到工作路径
addpath(genpath('Indicator_calculation/'));
xl=[0 0];
xu=[1 2];
pop=20*2;
Max_fevs=10000*2;
Max_Gen=fix(Max_fevs/pop);
fname='MMF2';
n_obj=2;
n_var=2;
%%
MODEDat.NOBJ = n_obj;                          % Number of objectives
MODEDat.NVAR   = n_var;                        % Numero of decision variables                    % Cost function instance
MODEDat.FieldD =[xl;xu]';
MODEDat.XPOP = pop;                        % Population size
MODEDat.Esc = 0.5;                         % Scaling factor
MODEDat.Pm= 0.5;             % Croosover Probability
beta=0.5;
MODEDat.InitialPop=[];                     % Initial population (if any)
MODEDat.MAXGEN =Max_Gen;                   % Generation bound

%% Initialization (don't modify)
MODEDat.CounterGEN=0;
MODEDat.CounterFES=0;

%% Reading parameters from MODEDat
Generaciones  = MODEDat.MAXGEN;    % Maximum number of generations.
Xpop          = MODEDat.XPOP;      % Population size.
Nvar          = MODEDat.NVAR;      % Number of decision variables.
Nobj          = MODEDat.NOBJ;      % Number of objectives.
Bounds        = MODEDat.FieldD;    % Optimization bounds.
ScalingFactor = MODEDat.Esc;       % Scaling fator in DE algorithm.
CrossOverP    = MODEDat.Pm;        % Crossover probability in DE algorithm.

%% Initial random population
Parent = zeros(Xpop,Nvar);  % Parent population.
Mutant = zeros(Xpop,Nvar);  % Mutant population.
Child  = zeros(Xpop,Nvar);  % Child population.
FES    = 0;                 % Function Evaluation.
for xpop=1:Xpop
    for nvar=1:Nvar
        Parent(xpop,nvar) = xl(nvar)+(xu(nvar)...
                            - xl(nvar))*rand();%随机初始化种群
    end
end
if size(MODEDat.InitialPop,1)>=1
    Parent(1:size(MODEDat.InitialPop,1),:)=MODEDat.InitialPop;
end
for xpop=1:Xpop
    JxParent(xpop,1:Nobj) = feval(fname,Parent(xpop,:));%求Parent对应的函数值
end

FES = FES+Xpop;   

%% Evolution process

for n=1:Generaciones
    % 进化种群P
    npop=Xpop;
    nvar=Nvar;
    nobj=Nobj;
    POP=zeros(npop,nvar+nobj);%结构体的种群转矩阵形式的种群
    for i=1:npop
    POP(i,1:nvar)=Parent(i);
    POP(i,nvar+1:nvar+nobj)=JxParent(i);
    end
    [L idx]=Affinity_Propagation(POP,nvar,nobj);%聚成了L类以及每个点所属那个簇中心的列向量
    %     disp('聚类完成')
    unique(idx);%类的中心索引
    B=cell(L,1);%元胞数组记录聚类情况
         j=1;
         for i=unique(idx)' %循环，每次取一个类的中心
             ii=find(idx==i); %找到与这个类中心在一个类的其它个体
             flag=double(ii~=i); %0所在的位置即是类中心
%              s=find(flag==0);
             B{j,1}=[ii,POP(ii,:)]; %放在元胞数组里,第一列为这一类里的成员序号   
%              B{j,1}(s,:)=[];%删除自身（类的中心）
             j=j+1;
         end
         %  来源2
         M=zeros(L,nvar+nobj+1);%全局子种群（每个类里随机选择一个）
         for i=1:L
         k=size(B{i,1},1);
         M(i,:)=B{i,1}(randperm(k, 1),:);%M的第一列为随机选取的那些成员
         end
         %来源1
         J=zeros(npop,1);
         for i=1:npop
             for j=1:L
               findresult=find(i==B{j,1}(:,1));
               if isempty(findresult)==0
               J(i)=j;  %个体i对应于第j类
               end
             end
         end
         
         %%  产生新解
         for i=1:npop
             if rand<beta        %来源1
                 po=B{J(i),1};
                 j=randi([1 size(po,1)],1,2);%产生1行三列的范围在1：npop之间的随机整数
                 p1=po(j(1),2:nvar+1);%二元锦标赛选择的第一个个体
                 p2=po(j(2),2:nvar+1);% 二元锦标赛选择的第二个个体
               
             else                 %来源2
                 po=M;
                 j=randi([1 size(po,1)],1,2);%产生1行三列的范围在1：npop之间的随机整数
                 p1=po(j(1),2:nvar+1);%二元锦标赛选择的第一个个体
                 p2=po(j(2),2:nvar+1);% 二元锦标赛选择的第二个个体
                
             end
         end
        %复制结束  
    for xpop=1:Xpop
         rev=randperm(Xpop); %随机打乱一个数字序列，保证选出的三个个体不相同
         %% Mutant vector calculation
         Mutant(xpop,:)=Parent(rev(1,1),:)+ScalingFactor*(p1-p2);
        
        % 控制新个体的变量范围
        for nvar=1:Nvar %Bounds are always verified
            if Mutant(xpop,nvar)<Bounds(nvar,1)
                Mutant(xpop,nvar) = Bounds(nvar,1);
            elseif Mutant(xpop,nvar)>Bounds(nvar,2)
                Mutant(xpop,nvar)=Bounds(nvar,2);
            end
        end
        
        %% Crossover operator
        for nvar=1:Nvar
            if rand() > CrossOverP
                Child(xpop,nvar) = Parent(xpop,nvar);
            else
                Child(xpop,nvar) = Mutant(xpop,nvar);
            end
        end
 end
 for xpop=1:Xpop
    JxChild(xpop,1:Nobj) = feval(fname,Child(xpop,:));%求Child对应的函数值
 end
    FES=FES+Xpop;

    %% Selection
     FZJxParent=[];%辅助种群的函数值
     FZParent=[];%%辅助种群
    for xpop=1:Xpop
        if JxChild(xpop,:) <= JxParent(xpop,:) 
            Parent(xpop,:) = Child(xpop,:);
            JxParent(xpop,:) = JxChild(xpop,:);
        elseif JxChild(xpop,:) > JxParent(xpop,:) 
            Parent(xpop,:) = Parent(xpop,:);
            JxParent(xpop,:) =  JxParent(xpop,:);
        else 
            FZParent = [FZParent;Child(xpop,:)]; %互相不支配的存放于FZParent
            FZJxParent =[FZJxParent;JxChild(xpop,:)];
        end
    end
    %种群合并
    HParent=[Parent;FZParent];% 合并
    HJxParent=[JxParent;FZJxParent];
    Hpop=CreateEmptyIndividuals(size(HParent,1)); %结构体的合并种群
    for i=1:numel(Hpop)%放值进去
    Hpop(i).Position=HParent(i,:);
    Hpop(i).Cost=HJxParent(i,:);
    end
    %非支配排序与拥挤度距离计算
    [pop F]=NonDominatedSorting1(Hpop);
%     numel(FZParent(:,1))
%     numel(Parent(:,1))  
    beta=(numel(FZParent(:,1))+10^(-10))/(numel(Parent(:,1))+10^(-10));
    pop=CalcCrowdingDistance(pop,F);
    R=[pop.Rank];
    [R R_sort_order]=sort(R);
    pop=pop(R_sort_order);
    pop=SortPopulation(pop);
    pop=pop(1:MODEDat.XPOP,:);
    % 输出结果
    PFront=[];
    PSet=[];
    for j=1:MODEDat.XPOP
	PSet=[PSet;pop(j).Position];%自变量
	PFront=[PFront;pop(j).Cost];%函数值
    end
    Parent=PSet;%自变量
    JxParent=PFront;%函数值
    PFront=JxParent;%函数值
	PSet=Parent;%自变量
    OUT.Xpop           = Parent;   % Population%自变量
    OUT.Jpop           = JxParent; % Poopulation's Objective Vector%函数值
    OUT.PSet           = PSet;     % Pareto Set%自变量
    OUT.PFront         = PFront;   % Pareto Front%函数值
    OUT.Param          = MODEDat;  % MODE Parameters
    MODEDat.CounterGEN = n;
    MODEDat.CounterFES = FES;

%     [OUT MODEDat]=PrinterDisplay(OUT,MODEDat); % To print results on screen

    if n>MODEDat.MAXGEN 
%         || FES>MODEDat.MAXFUNEVALS
        disp('Termination criteria reached.')
        break;
    end

end

OUT.Xpop=PSet;
OUT.Jpop=PFront;
ps=OUT.Xpop;
pf=OUT.Jpop;
% end


%% plot 
figure(1)
plot(ps(:,1),ps(:,2),'o')
figure(2)
plot(pf(:,1),pf(:,2),'o')







%% %%%%%%%%%%%%%%%%%%%%%%%%%%%% 子函数  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [L idx]=Affinity_Propagation(FPOP,nvar,nobj)
x=FPOP(:,nvar+1:nvar+nobj);
N=size(x,1);                 %N为矩阵的行数，即聚类数据点的个数；2是提取列数。
M=N*N-N;                  %N个点间有M条来回连线，考虑到从i到k和从k到i的距离可能是不一样的
s=zeros(M,3);              %定义一个M行3列的零矩阵,用于存放根据两个数据点计算出的相似度（放于第三列）
j=1;                              %通过for循环给s赋值，第一列表示起点i，第二列为终点k，第三列为i到k的负欧式距离作为相似度。
for i=1:N
for k=[1:i-1,i+1:N]       %实现对角线元素不赋值
s(j,1)=i;
s(j,2)=k;

 s(j,3)=-sum((x(i,:)-x(k,:)).^2);%欧式距离

%         a=x(i,:);
%         b=x(k,:);
%         c=dot(a,b)/(norm(a)*norm(b));%余弦值，余弦距离
%         s(j,3)=acos(c)*180/pi;%角度
%         s(j,3)=real(s(j,3));
j=j+1;
end
end
p=median(s(:,3));           %p为矩阵s第三列的中间值，即所有相似度值的中位数，用中位数作为preference,将获得数量合适的簇的个数
tmp=max(max(s(:,1)),max(s(:,2)));          
S=-Inf*ones(N,N);                           %-Inf负无穷大，定义S为N*N的相似度矩阵，初始化每个值为负无穷大
for j=1:size(s,1)                                %用for循环将s转换为S，S（i，j）表示点i到点j的相似度值
    S(s(j,1),s(j,2))=s(j,3);
end
nonoise=1;                                             %此处仅选择分析无噪情况（即S（i，j）=S（j,i）），所以略去下面几行代码                            
%if ~nonoise                                          %此处几行注释掉的代码是 在details,sparse等情况下时为了避免使用了无噪数据而使用的，用来给数据添加noise                   
%rns=randn('state');
%randn('state',0);
%S=S+(eps*S+realmin*100).*rand(N,N);
%randn('state',rns);
%end;
%Place preferences on the diagonal of S
if length(p)==1                                                  %设置preference
    for i=1:N
        S(i,i)=p;
    end
else
    for i=1:N
        S(i,i)=p(i);
    end
end
% Allocate space for messages ,etc
dS=diag(S);       %列向量，存放S中对角线元素信息
A=zeros(N,N);
R=zeros(N,N);
%Execute parallel affinity propagation updates
convits=50;maxits=500;                   %设置迭代最大次数为500次，迭代不变次数为50
e=zeros(N,convits);dn=0;i=0;          %e循环地记录50次迭代信息，dn=1作为一个循环结束信号，i用来记录循环次数
while ~dn
    i=i+1;
    %Compute responsibilities
    Rold=R;                                                          %用Rold记下更新前的R
    AS=A+S;                                                        %A(i,j)+S(i,j)
    [Y,I]=max(AS,[],2);                                          %获得AS中每行的最大值存放到列向量Y中，每个最大值在AS中的列数存放到列向量I中
 for k=1:N
      AS(k,I(k))=-realmax;                                     %将AS中每行的最大值置为负的最大浮点数，以便于下面寻找每行的第二大值
 end
    [Y2,I2]=max(AS,[],2);                                      %存放原AS中每行的第二大值的信息
     R=S-repmat(Y,[1,N]);                                    %更新R,R(i,k)=S(i,k)-max{A(i,k')+S(i,k')}      k'~=k  即计算出各点作为i点的簇中心的适合程度
    for k=1:N                                                       %eg:第一行中AS(1,2)最大,AS(1,3)第二大，
       R(k,I(k))=S(k,I(k))-Y2(k);                              %so R(1,1)=S(1,1)-AS(1,2); R(1,2)=S(1,2)-AS(1,3); R(1,3)=S(1,3)-AS(1,2).............                                                                           
    end                                                                 %这样更新R后，R的值便表示k多么适合作为i 的簇中心，若k是最适合i的点，则R(i,k)的值为正
  lam=0.5;  
  R=(1-lam)*R+lam*Rold;                                   %设置阻尼系数，防止某些情况下出现的数据振荡
  %Compute availabilities
  Aold=A;
  Rp=max(R,0);                                                   %除R(k,k)外，将R中的负数变为0，忽略不适和的点的不适合程度信息
  for k=1:N
      Rp(k,k)=R(k,k);
  end
  A=repmat(sum(Rp,1),[N,1])-Rp;                      %更新A(i,k),先将每列大于零的都加起来，因为i~=k,所以要减去多加的Rp(i,k)  

dA=diag(A);
  A=min(A,0);                                                     %除A(k,k)以外，其他的大于0的A值都置为0
  for k=1:N
      A(k,k)=dA(k);
  end
  A=(1-lam)*A+lam*Aold;                                  %设置阻尼系数，防止某些情况下出现的数据振荡          
  %Check for convergence
  E=((diag(A)+diag(R))>0);
  e(:,mod(i-1,convits)+1)=E;                               %将循环计算结果列向量E放入矩阵e中，注意是循环存放结果，即第一次循环得出的E放到N*50的e矩阵的第一列，第51次的结果又放到第一列
  K=sum(E);                                                         %每次只保留连续的convits条循环结果，以便后面判断是否连续迭代50次中心簇结果都不变。%%%%%%%%%%%%%%%%
  if i>=convits || i>=maxits                                 %判断循环是否终止
        se=sum(e,2);                                              %se为列向量，E的convits次迭代结果和
        unconverged=(sum((se==convits)+(se==0))~=N);%所有的点要么迭代50次都满足A+R>0，要么一直都小于零，不可以作为簇中心
        if (~unconverged&&(K>0))||(i==maxits)  %迭代50次不变，且有簇中心产生或超过最大循环次数时循环终止。
            dn=1;
        end
  end
end
I=find(diag(A+R)>0);               %经过上面的循环，便确定好了哪些点可以作为簇中心点，用find函数找出那些簇1中心点,这个简单demo中I=[2,4],
K=length(I); % Identify exemplars                                                                                                           %即第二个点和第四个点为这六个点的簇中心
if K>0                                      %如果簇中心的个数大于0
    [~,c]=max(S(:,I),[],2);           %取出S中的第二，四列；求出2，4列的每行的最大值，如果第一行第二列的值大于第一行第四列的值，则说明第一个点是第二个点是归属点
    c(I)=1:K; % Identify clusters   %c(2)=1,c(4)=2(第2个点为第一个簇中心，第4个点为第2个簇中心)
    % Refine the final set of exemplars and clusters and return results
    for k=1:K
        ii=find(c==k);                                          %k=1时，发现第1，2，3个点为都属于第一个簇                           
        [y,j]=max(sum(S(ii,ii),1));                         %k=1时 提取出S中1，2，3行和1，2，3列组成的3*3的矩阵，分别算出3列之和取最大值，y记录最大值，j记录最大值所在的列
       I(k)=ii(j(1));                                                %I=[2;4]
    end
    [tmp,c]=max(S(:,I),[],2);          %tmp为2，4列中每行最大数组成的列向量，c为每个最大数在S（：，I）中的位置，即表示各点到那个簇中心最近
    c(I)=1:K;                                  %c(2)=1;c(4)=2;
    tmpidx=I(c);                            %I=[2;4],c中的1用2替换，2用4替换
    %(tmpidx-1)*N+(1:N)'                                   %一个列向量分别表示S(1,2),S(2,2),S(3,2),S(4,4),S(5,4),S(6,4)是S矩阵的第几个元素
    %sum(S((tmpidx-1)*N+(1:N)'))                      %求S中S(1,2)+S(2,2)+S(3,2)+S(4,4)+S(5,4)+S(6,4)的和
    tmpnetsim=sum(S((tmpidx-1)*N+(1:N)'));    %将各点到簇中心的一个表示距离的负值的和来衡量这次聚类的适合度
    tmpexpref=sum(dS(I));                                  %dS=diag(S)；               %表示所有被选为簇中心的点的适合度之和
else
    tmpidx=nan*ones(N,1);  %nan Not A Number 代表不是一个数据。数据处理时，在实际工程中经常数据的缺失或者不完整，此时我们可以将那些缺失设置为nan
    tmpnetsim=nan;
    tmpexpref=nan;
end
netsim=tmpnetsim;                                           %反应这次聚类的适合度
dpsim=tmpnetsim-tmpexpref;                       
expref=tmpexpref;                                           
idx=c;                                                        %哈哈，记录了每个点所属那个簇中心的列向量
L=length(unique(idx));                                        %聚成了L类
end

function pop=CreateEmptyIndividuals(n)

    if nargin<1
        n=1;
    end
    
    individual.Position=[];
    individual.Cost=[];
    individual.Rank=[];
    individual.CrowdingDistance=[];
    
    pop=repmat(individual,n,1);
    
end

function C= cnstCmpMat(m,N)

[a,b]=sort(m); 
C=zeros(N,N);
for j=1:N
    C(b(1,1),j)=1;
end
for i=2:N
    if a(1,i)==a(1,i-1)
        C(b(1,i),:)=C(b(1,i-1),:);
    else
        for j=i:N
            C(b(1,i),b(1,j))=1;
        end
    end
end
end

function pop=CalcCrowdingDistance(pop,F)

    nobj=numel(pop(1).Cost);%目标函数个数
    nf=numel(F);  %分层数
    for f=1:nf   %逐层遍历
        A=F{f};
        C=GetCosts(pop(A));
        D=zeros(size(C));
        for j=1:nobj
            
            [SCj k]=sort(C(j,:));
            
            D(j,k(1))=inf;
            D(j,k(end))=inf;
            D(j,k(2:end-1))=(SCj(3:end)-SCj(1:end-2))/(SCj(end)-SCj(1));
        end
        
        D=sum(D,1);
        for i=1:numel(A)
            pop(A(i)).CrowdingDistance=D(i);
        end
        
    end

end

function costs=GetCosts(pop)

    nobj=numel(pop(1).Cost);
    
    costs=reshape([pop.Cost],nobj,[]);

end

function pop=SortPopulation(pop)

    CD=[pop.CrowdingDistance];
    [CD CD_sort_order]=sort(CD,'descend');
    pop=pop(CD_sort_order);
    
    R=[pop.Rank];
    [R R_sort_order]=sort(R);
    pop=pop(R_sort_order);
    
end

function [Frente Conjunto]=DominanceFilter(F,C)

Xpop=size(F,1);
Nobj=size(F,2);
Nvar=size(C,2);
Frente=zeros(Xpop,Nobj);
Conjunto=zeros(Xpop,Nvar);
k=0;

for xpop=1:Xpop
    Dominado=0;
    
    for compara=1:Xpop
        if F(xpop,:)==F(compara,:)
            if xpop > compara
                Dominado=1;
                break;
            end
        else
            if F(xpop,:)>=F(compara,:)
                Dominado=1;
                break;
            end
        end
    end
    
    if Dominado==0
        k=k+1;
        Frente(k,:)=F(xpop,:);
        Conjunto(k,:)=C(xpop,:);
    end
end
Frente=Frente(1:k,:);
Conjunto=Conjunto(1:k,:);
end

function [pop F]=NonDominatedSorting1(pop)
npop=numel(pop);
chromosome=[];
V=0;
for i=1:npop
chromosome=[chromosome;pop(i).Cost];
end
[N,MM]=size(chromosome);
x=chromosome;
Y=x';
for i=1:MM%f1,f2
eval(['Y',num2str(i),'=','Y(i,:)',';']);
end
D=zeros(npop,npop);
 for i=1:MM
     m=Y(i,:);
     m;
     C=cnstCmpMat(m,N);
     D=D+C;
 end
D;
for i=1:npop%������Ŀ
    D(i,i)=0;
    for j=i+1:npop
        if D(i,j)==D(j,i)
             D(i,j)=0;
             D(j,i)=0;
        end
    end
end
D;
count=0;
front=1;
while count<npop
Q=[];
for i=1:npop
    M=max(D);
  if  M(i)>=0 && M(i)<MM
       Q=union(Q,i); 
      
       count=count+1; 
     
  end
end
for i=1:npop
       h=ismember(i,Q);
        if h==1
        D(i,:)=-1;
        D(:,i)=-1;
        a=front; 
          pop(i).Rank=a;
    
        end
end
  D;
Var_Value =Q;
   for j = front
   Name = ['F',num2str(j)];
    eval([Name,'=Var_Value']);
    front=front+1;
    G=[Var_Value];
   end
end
   front;
F=cell(1,front-1);
for i=1:front-1
Name = ['F',num2str(i)];
F{1,i}=eval(Name);
end
end
